/*
 * Created on 18.10.2004
 * $Id: TraceAspect.java,v 1.1 2004/10/19 15:17:11 Heiko Exp $
 */
package de.bsd.adb.aop;

import java.lang.reflect.Method;


import org.jboss.aop.advice.Interceptor;
import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.MethodInvocation;
import org.jboss.logging.Logger;

/**
 * @author hwr@pilhuhn.de
 * @version $Revision: 1.1 $
 */
public class TraceAspect implements Interceptor {

	Logger log = Logger.getLogger(TraceAspect.class);

	public String getName() {
		// TODO Auto-generated method stub
		return "TraceAspect";
	}

	
	public Object invoke(Invocation inv) throws Throwable {
		long start,now;
		
		String meth;
		if (inv instanceof MethodInvocation) {
			MethodInvocation minv = (MethodInvocation) inv;
			meth= getClassDotMethod(minv.getMethod());
		}
		else {			
			meth= "unknown ";
		}
		
		
		start = System.currentTimeMillis();
		Object ret = inv.invokeNext();
		now = System.currentTimeMillis();
		log.info(meth + (now-start) + "ms");
		
		return ret;
	}
	
	
	
	// Die Klasse der uebergebenen Methode ohne Paket
	// ermitteln und als Klasse.Methode: zurueckgeben.
	private String getClassDotMethod(Method m)
	{
		String cl = m.getDeclaringClass().getName();
		int pos = cl.lastIndexOf(".");
		// Paket abschneiden falls vorhanden
		if (pos!=-1)
			cl=cl.substring(pos+1);	
		cl += ".";
		cl += m.getName();
		cl += ": ";
		return cl;
	}
}
