/*
 * Created on 02.05.2004
 * $Id: LoginCallbackHandler.java,v 1.2 2004/10/06 13:31:34 Heiko Exp $
 */
package de.bsd.adb.client;

import java.io.IOException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;

/**
 * @author hwr@pilhuhn.de
 * @version $Revision: 1.2 $
 */
public class LoginCallbackHandler implements CallbackHandler {

	private String user;
	private char[] pass;
	
	LoginCallbackHandler(String username,char[] password) {
		user=username;
		pass=password;
	}
	
	/**
	 * @see javax.security.auth.callback.CallbackHandler#handle(javax.security.auth.callback.Callback[])
	 */
	public void handle(Callback[] callbacks)
		throws IOException, UnsupportedCallbackException {
		
		for (int i =0 ; i< callbacks.length; i++) {
		
			if (callbacks[i] instanceof NameCallback)
			{
				System.out.println("NameCallback");
				NameCallback nc = (NameCallback)callbacks[i];
				nc.setName(user);
			}
			else if (callbacks[i] instanceof PasswordCallback)
			{
				System.out.println("PasswordCallback");
				PasswordCallback pc = (PasswordCallback)callbacks[i];
				pc.setPassword(pass);
			}
			else {
				throw new UnsupportedCallbackException(callbacks[i],"Ouch");	
			}
		}
	}

}
