/*
 * Created on 13.10.2004
 * $Id: ADBMessageDrivenBean.java,v 1.3 2005/01/04 20:00:57 Heiko Exp $
 */
package de.bsd.adb.ejb;

import javax.ejb.MessageDrivenBean;
import javax.jms.Message;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.bsd.adb.beans.AddrBean;

/**
 * @author hwr@pilhuhn.de
 * @version $Revision: 1.3 $
 * 
 * @ejb.bean name="ADBMessageDriven"
 *   
 * @jboss.destination-jndi-name name="queue/adbQueue"
 * 
 */
public abstract class ADBMessageDrivenBean 
	implements MessageDrivenBean,javax.jms.MessageListener 
{

	FacadeLocalHome flh = null;
	InitialContext ic=null;
	Queue replyQueue=null;
	QueueConnectionFactory factory=null;
	
	public void ejbCreate()
	{
		try {
			ic = new InitialContext();			
			factory = (QueueConnectionFactory)
				ic.lookup("UIL2ConnectionFactory");
			flh = (FacadeLocalHome) ic.lookup("adb/FacadeLocal");
		} catch (NamingException e) {			
			System.err.println("Error: " + e.getMessage());
		}		
	}
	
	/**
	 * Wartet auf Anfragen des Clients und schickt dann
	 * eine Antwort zurck.
	 * @see javax.jms.MessageListener#onMessage(javax.jms.Message)
	 */
	public void onMessage(Message msg) {		
		
		try {
			AddrBean[] aout = null;
			if (msg instanceof ObjectMessage) {
				ObjectMessage omes = (ObjectMessage)msg;
				AddrBean ain = (AddrBean)omes.getObject();
				
				FacadeLocal fa = flh.create();
				aout = fa.suche(ain.getName(),ain.getVorname());
				
				replyQueue = (Queue) omes.getJMSReplyTo();
			}
			else {
				System.out.println("Unknown Message: " + msg );
				return;
			}
						
			// Antwort senden						
			QueueConnection connection = factory.createQueueConnection();
			QueueSession session = connection.createQueueSession(false,
					Session.AUTO_ACKNOWLEDGE);

			QueueSender sender = session.createSender(replyQueue);
			ObjectMessage message = session.createObjectMessage(aout);
			sender.send(message);
			
		}
		catch (Exception e) {
			System.err.println(e.getMessage());
		}
	}
}
