/*
 * Created on 03.01.2005
 * $Id: UserAdminEntityBean.java,v 1.1 2005/01/04 20:00:57 Heiko Exp $
 */
package de.bsd.adb.ejb;

import javax.ejb.CreateException;
import javax.ejb.EntityBean;

/**
 * Dieses Bean verwaltet die Benutzer, Rollen
 * und Passworte
 * 
 * @ejb.bean name="UserAdmin"
 * 	type="CMP"
 * 	cmp-version = "2.x"
 * 	view-type = "local"
 * 	local-jndi-name="adb/UserAdmin"
 * 	primkey-field = "uid"
 * 
 * @ejb.persistence table-name = "Adb_UserAdmin"
 * @jboss.persistence 
 * 	create-table = "${create.table}"
 * 	remove-table = "${remove.table}"
 * 	post-table-create = "INSERT INTO Adb_UserAdmin (uid,password,roles) values('elke','abc','ADBadmin')" 
 * 
 */
public abstract class UserAdminEntityBean implements EntityBean {

	/** @ejb.create-method */
	public String ejbCreate(String uid, String password, String roles)
		throws CreateException 
	{
		setUid(uid);
		setPassword(password);
		setRoles(roles);
		
		return null;
	}
	
	/** 
	 * @ejb.persistence
	 * @ejb.interface-method
	 * @jboss.persistence dbindex="true"  
	 */
	public abstract String getUid();
	public abstract void setUid(String uid);
	
	/** @ejb.persistence */
	public abstract String getPassword();
	/** @ejb.interface-method */
	public abstract void setPassword(String pass);
	
	/**
	 * @ejb.persistence
	 * @ejb.interface-method
	 */
	public abstract String getRoles();
	
	/** @ejb.interface-method */
	public abstract void setRoles(String roles);
}