/*
 * Created on 11.10.2004
 * $Id: WSFacadeSessionBean.java,v 1.3 2005/01/05 18:23:04 Heiko Exp $
 */
package de.bsd.adb.ejb;

import java.util.Iterator;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.naming.InitialContext;

import org.apache.log4j.Logger;

import de.bsd.adb.beans.AddrBean;

/**
 * Web services facade fuer die Adress-DB
 * @version $Revision: 1.3 $
 * 
 * @ejb.bean name="WSFacade"
 * 	type="Stateless"
 * 	view-type="service-endpoint"
 * 
 * @wsee.port-component
 * 	name="WSFacadeServicePort" 	
 * 
 * @ejb.interface 
 *   service-endpoint-class="de.bsd.adb.ejb.WSFacadeService"
 */
public abstract class WSFacadeSessionBean implements SessionBean {

   private static final Logger log = Logger.getLogger(WSFacadeSessionBean.class);	
	FacadeLocal fl=null;
	FacadeLocalHome flh = null;
	
	/** @ejb.permission unchecked = "true" */
	public void ejbCreate()	
	{
		try {
			InitialContext ic = new InitialContext();
			Object o = ic.lookup("adb/FacadeLocal");
			flh = (FacadeLocalHome) o;			
		}
		catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	/** 
	 * @ejb.interface-method
	 * @ejb.permission unchecked = "true"
	 */
	public String[] sucheEmail (String name, String vorname)
	{
		String[] emails = null;
		try {
			fl = flh.create();
			AddrBean[] adr = fl.suche(name,vorname);
			if (adr!=null) {
				if (adr[0].getEmails()!=null) {  // Nur emails der ersten Fundstelle
					int i = adr[0].getEmails().size();
					emails = new String[i];
					Iterator it = adr[0].getEmails().iterator();
					i=0;
					while (it.hasNext()) {
						emails[i]= (String)it.next();
						i++;
					}
				}
			}				
			else
				emails=null;
			return emails;			
		} catch (CreateException e) {
			System.err.println("Fehler: " + e.getMessage());
			return null;
		}		
	}
	
	/**
	 * @ejb.interface-method 
	 * @ejb.permission unchecked = "true"
	 * @param msg
	 */
	public void log(String msg)
	{
		System.out.println("LogMessage: " + msg);
	}
	
	/**
	 * Casting service
	 * @ejb.interface-method 
	 * @ejb.permission unchecked = "true"
	 * @param in
	 * @return
	 */
	public int toInt(float in) 
	{
		return (int)in;
	}
}
