package de.bsd.adb.interceptor;

import java.lang.reflect.Method;

import org.jboss.ejb.plugins.AbstractInterceptor;
import org.jboss.invocation.Invocation;

public class TimingInterceptor 
	extends AbstractInterceptor 
{
	private long startTime, now;
	private Object res = null;
	private String mName;
	
	// Aufrufe der Bean-Methoden
	public Object invoke(Invocation inv) 
		throws Exception 
	{
		mName = getClassDotMethod(inv.getMethod());
		startTime = System.currentTimeMillis();
		// Weiter an naechsten Interceptor
		res = super.invoke(inv);
		now = System.currentTimeMillis();				
		log.info("invoke() " + mName  + 
				(now-startTime) + " ms");
		return res;
	}

	// Aufrufe auf die Home-Schnittstelle der Beans
	public Object invokeHome(Invocation inv) 
		throws Exception 
	{
		mName = getClassDotMethod(inv.getMethod());
		startTime = System.currentTimeMillis();
		// Weiter an naechsten Interceptor
		res = super.invokeHome(inv);
		now = System.currentTimeMillis();		
		log.info("invokeHome() " + mName  +  
				(now-startTime) + " ms");
		return res;		
	}
	
	// Die Klasse der uebergebenen Methode ohne Paket
	// ermitteln und als Klasse.Methode: zurueckgeben.
	private String getClassDotMethod(Method m)
	{
		String cl = m.getDeclaringClass().getName();
		int pos = cl.lastIndexOf(".");
		// Paket abschneiden falls vorhanden
		if (pos!=-1)
			cl=cl.substring(pos+1);	
		cl += ".";
		cl += m.getName();
		cl += ": ";
		return cl;
	}
}