/*
 * Created on 14.10.2004
 * $Id: MQClient.java,v 1.3 2005/01/04 20:00:56 Heiko Exp $
 */
package de.bsd.adb.mqclient;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Collection;
import java.util.Iterator;
import java.util.Properties;

import javax.jms.Message;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueReceiver;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.TemporaryQueue;
import javax.naming.InitialContext;

import de.bsd.adb.beans.AddrBean;



/**
 * @author hwr@pilhuhn.de
 * @version $Revision: 1.3 $
 */
public class MQClient {

	public static void main(String[] args) {
		
		String name, vorname;
		
		try {
			Properties p = new Properties();
			// Knnten auch aus einer Datei jndi.properties geladen werden
			p.put("java.naming.factory.initial",
				"org.jnp.interfaces.NamingContextFactory");
			p.put("java.naming.factory.url.pkgs",
				"org.jboss.naming:org.jnp.interfaces");
			p.put("java.naming.provider.url","jnp://localhost:1099");

			InitialContext ic = new InitialContext(p);
			Queue queue = (Queue) ic.lookup("queue/adbQueue");
			QueueConnectionFactory factory = (QueueConnectionFactory)
			ic.lookup("UIL2ConnectionFactory");

			InputStreamReader isr = new InputStreamReader(System.in,"ISO-8859-1");
			BufferedReader br = new BufferedReader(isr);

			System.out.print("Name: ");
			System.out.flush();
			name=br.readLine();
			System.out.print("Vorname: ");
			System.out.flush();
			vorname=br.readLine();

			
			AddrBean adr = new AddrBean();
			adr.setName(name);
			adr.setVorname(vorname);
			
			
			QueueConnection connection = factory.createQueueConnection();
			
			connection.setClientID("Heikos Client");
			
			
			//connection.start();

			QueueSession session = connection.createQueueSession(false,
							Session.AUTO_ACKNOWLEDGE);

			TemporaryQueue tmpQ = session.createTemporaryQueue();			
			QueueSender sender = session.createSender(queue);			
			
			ObjectMessage om = session.createObjectMessage(adr);
			om.setJMSReplyTo(tmpQ);
			sender.send(om);

			
			System.out.println("Warten auf das Resultat");
			QueueReceiver qr = session.createReceiver(tmpQ);
			
			connection.start();
			
			Message in = qr.receive();
			
			if (in instanceof ObjectMessage) {
				ObjectMessage omin = (ObjectMessage) in;
				AddrBean[] rcv = (AddrBean[])omin.getObject();
				
				int size = 0;
				if (rcv!=null)
					size = rcv.length;
				
				System.out.println(size + " Adresse(n) gefunden");
				for (int i = 0 ; i< size ; i++) {
					System.out.println((i+1) + ") " + rcv[i].getName() + ", " + rcv[i].getVorname());
					Collection mails = rcv[i].getEmails();
					if (mails==null) {
						System.out.println("Keine Email gefunden");
					}
					else {
						Iterator it = mails.iterator();
						while (it.hasNext()) {
							System.out.println("  " + (String)it.next());
						}
					}
				}				
			}
			
			System.out.println("Zum Beenden bitte Enter drcken");
			br.readLine();
			
			connection.close();
			session.close();
			
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
