package de.bsd.adb.servlets;

import java.io.IOException;
import java.util.ArrayList;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import de.bsd.adb.beans.AddrBean;
import de.bsd.adb.ejb.Facade;
import de.bsd.adb.ejb.FacadeHome;

public class WorkerServlet extends HttpServlet {	
	// Operations Modi
	private final static int SEARCH = 0;
	private final static int ADD =1;
	
	private FacadeHome fh;
	private String targetPage = "/index.jsp";

	// nur HTTP POST Methode
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
		
		String tasks = req.getParameter("task");
		
		
		int task;
		if ("add".equals(tasks))
			task=ADD;
		else if ("search".equals(tasks))
			task=SEARCH;
		else {
			resp.sendError(HttpServletResponse.SC_EXPECTATION_FAILED,
				"bad request");
			return;
		}
		
		AddrBean[] addrs = null;
		switch(task) {
			case ADD:
				addrs = handleAdd(req);
				break;
			case SEARCH:				
				addrs = handleSearch(req);
				break;			
		}
		// Ergebnis an Session geben		
		HttpSession session = req.getSession(true);
		
		session.setAttribute("addrs",addrs);
		// Request weiterleiten		
		RequestDispatcher rd = getServletContext().
				getRequestDispatcher(targetPage);
			rd.forward(req, resp); 		
	} 

	// erledigt die Suche
	private AddrBean[] handleSearch(HttpServletRequest req) {
		AddrBean[] result = null;
		String name=req.getParameter("name");
		try {
			Facade fa = fh.create();
			result = fa.suche(name,null);	
			fa.remove();
		} catch (Exception e) {
			result = null;
		}
		targetPage = "/index.jsp";
		return result;
	}

	// erledigt das Neu hinzufgen
	private AddrBean[] handleAdd(HttpServletRequest req) {

		AddrBean a = new AddrBean();
		AddrBean[] result = new AddrBean[1]; 
		ArrayList mails = new ArrayList();
		mails.add(req.getParameter("email"));
		mails.add(req.getParameter("email2"));
		
		a.setEmails(mails);
		a.setName(req.getParameter("name"));
		a.setVorname(req.getParameter("vorname"));
		a.setOrt(req.getParameter("ort"));
		a.setPlz(req.getParameter("plz"));
		a.setTel(req.getParameter("tel"));
		a.setStrasse(req.getParameter("strasse"));
		
		try {
			System.out.println("add");
			Facade fa = fh.create();
			fa.add(a);
			System.out.println("add2, fa:" + fa);
			fa.remove();
			result[0]=a;
		}
		catch (Exception e) {
			// XXX set result code
		}		
		
		targetPage = "/index.jsp";
		return result; 
	}
	
	 
	
	public void init() throws ServletException {
		System.out.println("init");
		try {
			InitialContext ic = new InitialContext();
			Object o = ic.lookup("adb/Facade");
			fh = (FacadeHome) o;
		} catch (NamingException e) {
			fh = null;
			throw new ServletException(e);
		}
	}

} // class
